{ Created: 2001-11-20 by Berend de Boer <berend@pobox.com>
 
  See http://www.pobox.com/~berend/delphi for updates.


  Contains Unicode routines for Delphi 5 with the same names as
  available in Delphi 6 or Kylix. One solution would be to copy the
  code from Kylix's System unit. I decided to use the Windows routines.

}


{$IFDEF VER130}
{$DEFINE NEED_UTF_UTILS}
{$ENDIF}

unit utf_util;

interface

const { due to Delphi being little endian, the chars are reversed!! }
  BigEndianByteOrderMark:WideChar = #$fffe;
  LittleEndianByteOrderMark:WideChar = #$feff;
  
{$IFDEF NEED_UTF_UTILS}
type
  UTF8String = type string;
  PUTF8String = ^UTF8String;

{ WideString <-> UTF8 conversion }

function UTF8Encode(const WS: WideString): UTF8String;
function UTF8Decode(const S: UTF8String): WideString;
{$ENDIF}


implementation

{$IFDEF NEED_UTF_UTILS}
uses
  Windows;
{$ENDIF}


{$IFDEF NEED_UTF_UTILS}
{ WideString <-> UTF8 conversion }

function UTF8Encode(const WS: WideString): UTF8String;
var
  Temp: UTF8String;
  MaxTempLen: Integer;
  NumChars: Integer;
begin
  MaxTempLen := length(WS)*3+1;
  SetLength(Temp, MaxTempLen);
  NumChars := WideCharToMultiByte(CP_UTF8, 0, PWideChar(WS), length(WS), PChar(Temp), MaxTempLen, nil, nil);
  if NumChars > 0 then
    SetLength(Temp, NumChars)
  else
    Temp := '';
  Result := Temp;
end;

function UTF8Decode(const S: UTF8String): WideString;
var
  Temp: WideString;
  MaxTempLen: Integer;
  NumWideChars: Integer;
begin
  MaxTempLen := length(S)+1;
  SetLength(Temp, MaxTempLen);
  NumWideChars := MultiByteToWideChar(CP_UTF8, 0, PChar(S), length(S), PWideChar(Temp), MaxTempLen);
  if NumWideChars > 0 then
    SetLength(Temp, NumWideChars)
  else
    Temp := '';
  Result := Temp;
end;
{$ENDIF}


end.